enter = {}

function enterButton(x,y,button)
	if button == "l" then
		temp = function() EndState("home") end
		RegTimer(0.2, temp)
		
	end
	
end

function enter.load()
	enter.background = love.graphics.newImage("img/Enter_Background.png")
	enter.mask = love.graphics.newImage("img/Enter_Background_Mask2.png")
	
	buttonGraphics =
	{
		["default"]=love.graphics.newImage("img/buttonStyle1Default.png"),
		["over"]=love.graphics.newImage("img/buttonStyle1Over.png"),
		["down"]=love.graphics.newImage("img/buttonStyle1Down.png"),
	}
	
	for _, i in ipairs(buttonGraphics) do
	
		i:setFilter("nearest","nearest")
		
	end
	
	
	SetConst("textFont", love.graphics.newFont("fonts/Text.ttf",16))
	SetConst("buttonFont",love.graphics.newFont("fonts/Buttons.ttf", 25))
	SetConst("buttonStyle1", buttonGraphics)
	
	print("fonts set")
	
	print("Creating enter.gui")
	enter.gui = List:new()
	enter.text= List:new()
	
	print(enter.gui)
	
	enter.debug = ""
	
	enterText = TextObject:new(Vector2:new(), "ENTER", GetConst("buttonFont"))
	enter.gui:add(Button:new(Vector2:new(200, 200),enterButton,buttonGraphics,enterText))
	
	print("'Enter' loaded!")
end



mask_effect = love.graphics.newShader [[
   vec4 effect ( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords ) {
      // a discarded fragment will fail the stencil test.
      if (Texel(texture, texture_coords).rgb == vec3(0.0))
         discard;
      return vec4(1.0);
   }
]]

enter.stencil = function ()
   love.graphics.setShader(mask_effect)
   love.graphics.draw(enter.mask, 0, 0)
   love.graphics.setShader()
end

function enter.onStart(args)
	
	love.window.setMode(550, 400, {["borderless"]=true})
	love.window.setTitle("Enter")
end

function enter.update(dt)
	
	enter.gui:mousehover(love.mouse.getX(), love.mouse.getY())
	
end

function enter.draw()
	
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(enter.background)
	
	
	love.graphics.setStencil(enter.stencil)
		
		enter.text:draw()
		
		enter.gui:draw()
		
		
		--Shade everything green
		love.graphics.setColor(81,222,62, 75)
		love.graphics.rectangle("fill",0,0,550,400)
		
			
		
	love.graphics.setStencil()
	
	love.graphics.setColor(0,255,100)
	love.graphics.print(enter.debug,50,50)
	
end

function enter.mousepressed(x,y,button)
	
	enter.gui:mousepressed(x,y,button)
	
end

function enter.mousereleased(x,y,button)
	
	enter.gui:mousereleased(x,y,button)
	
end

RegState("enter",enter)
RegInitialState("enter")