--Buy stufffff...

local screen = {}

function screen:new(frames)
	
	local o = {}
	
	o.frames = frames
	o.frame = 1
	o.length = #frames
	o.speed = 0.1
	o.t = 0
	
	o.pos = Vector2:new(70, 353)
	o.scale = Vector2:new(0.1,0.1)
	
	local frameWidth = 960 * o.scale.x
	--local frameHeight = 540 * o.scale.y
	
	o.TVScale = frameWidth/TVImage:getWidth()
	
	self.__index = self
	return setmetatable(o, self)
end

function screen.stencil()
	love.graphics.setShader(mask_effect)
	love.graphics.draw(TVMask, s.pos.x, s.pos.y, 0, s.TVScale)
	love.graphics.setShader()
end

function screen:update(dt)
	self.t = self.t + dt
	
	if self.t > self.speed then
		--print("Incrementing frame!")
		--print("Frame is "..self.frame)
		frameIncrease = math.floor(self.t / self.speed)
		
		self.frame = self.frame + frameIncrease
		--print("Now it's "..self.frame)
		
		--print("self.t is "..self.t)
		self.t = self.t - self.speed
		--print("now it's "..self.t)
	end
	
	if self.frame > self.length then
		--print("Reached end!")
		self.frame = self.frame - self.length
		--print("Frame is now "..self.frame)
	end
	
end



function screen:draw()
	
	love.graphics.draw(TVImage, self.pos.x, self.pos.y, 0, self.TVScale)
	
	love.graphics.setStencil(self.stencil)
	
	love.graphics.draw(self.frames[self.frame], self.pos.x - 105 * self.scale.x, self.pos.y, 0, self.scale.x + 0.03, self.scale.y + 0.03)
	
	love.graphics.setStencil()
end

Item = {}


LightCone = {}

function LightCone:new(pos)

	local o = {}

	o.pos = pos
	o.lit = true

	self.__index = self
	return setmetatable(o, self)

end

function LightCone:draw()
	if not self.lit then return end
	
	
	
	love.graphics.draw(lightImage, self.pos.x, self.pos.y)

end

function LightCone:update(dt)

	if self.lit then
		if randomPercent(1/200) then

			self.lit = false

		end
	else

		if randomPercent(1/7) then
			self.lit = true
		end

	end
end

merch = {}

function merch.load()
	
	merch.background = love.graphics.newImage("img/Shop.png")
	merch.shelves = love.graphics.newImage("img/ShopShelves.png")
	merch.mask = love.graphics.newImage("img/ShopShelvesMask.png")

	merch.gui = List:new()
	
	merch.items = List:new()
	merch.lights = List:new()
	
	lightLocs = 
	{
		{30,212},
		{306, 201},
		{530, 191},
		{292, 335},
	}
	
	for i, l in ipairs(lightLocs) do
		
		merch.lights:add(LightCone:new(Vector2:new(l[1]-(108), l[2])))
		
	end
	
	juicy = love.graphics.newImage("img/Juicy.png")
	juicy:setFilter("nearest","nearest")
	
	merch.items:add(GenericDrawable:new(Vector2:new(510,260), juicy))
	
	albumFront = love.graphics.newImage("img/RED-Front.png")
	albumFront:setFilter("nearest","nearest")
	
	--Put a 2 pixel border around the album so it stands out
	merch.items:add(RectangleDrawable:new(Vector2:new(268, 268), Vector2:new( (albumFront:getWidth()*0.1) + 4, (albumFront:getHeight()*0.1)+4 ), {0,0,0}))
	
	merch.items:add(GenericDrawable:new(Vector2:new(270, 270), albumFront, Vector2:new(0.1,0.1)))
	
	
	
	
	--merch.lights:add(LightCone:new(Vector2:new(-50, 330)))

	p=GetConst("pause")
	
	print(p.update)
	
	merch.gui:add(p)
	
	TVImage = love.graphics.newImage("img/ShopTV.png")
	TVMask = love.graphics.newImage("img/ShopTVMask.png")
	
	lightImage = love.graphics.newImage("img/LightCone.png")
	
	frameStart = 400
	frameEnd = 500
	frameSkip = 5
	
	frames = {}
		
	for i = frameStart, frameEnd, frameSkip do
		name = string.format("img/Frames/Frame%04d.png", i)
		table.insert(frames, love.graphics.newImage(name))
	end
	
	
	s = screen:new(frames)
	
	print(s.update)
	
	merch.gui:add(s)
	
end


function merch.stencil()
	love.graphics.setShader(mask_effect)
	love.graphics.draw(merch.mask)
	love.graphics.setShader()
end


function merch.onStart()
	
	love.window.setMode( 640,500, {["borderless"]=true})
	
end

function merch.update(dt)
	
	merch.lights:update(dt)
	merch.items:update(dt)

	merch.gui:mousehover(love.mouse.getX(), love.mouse.getY())
	
	merch.gui:update(dt)
	
end

function merch.draw()

	love.graphics.setColor(255,255,255)
	love.graphics.draw(merch.background)
	
	love.graphics.draw(merch.shelves)
	
	merch.items:draw()
	
	love.graphics.setStencil(merch.stencil)
	
	love.graphics.setColor(210,230,255,100)
	merch.lights:draw()

	love.graphics.setStencil()
	
	merch.gui:draw()
	
end

function merch.mousepressed(x,y,button)
	
	merch.gui:mousepressed(x,y,button)
	
	print(tostring(Vector2:new(x,y)))
	
end

function merch.mousereleased(x,y,button)
	
	merch.gui:mousereleased(x,y,button)
	
end

RegState("merch",merch)